#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire10five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 10"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire10five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five104xi            # 10   - 90 

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
         
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + ) - READ FROM FILES
# -------------------------------------------------------------------------------------------------    

shot2five104xi = {
                1: '-10x10y12z',
                2: '-10x12y36z',
                3: '-10x45y17z',
                4: '-11x10y12z',
                5: '-11x11y36z',
                6: '-11x49y61z',
                7: '-12x11y36z',
                8: '-12x45y17z',
                9: '-12x9y12z',
                10: '-13x11y35z',
                11: '-13x49y61z',
                12: '-13x7y12z',
                13: '-13x8y12z',
                14: '-14x10y35z',
                15: '-14x6y11z',
                16: '-14x7y11z',
                17: '-15x4y11z',
                18: '-15x5y11z',
                19: '-15x9y35z',
                20: '-16x3y11z',
                21: '-16x49y60z',
                22: '-16x8y35z',
                23: '-16x9y35z',
                24: '-17x7y35z',
                25: '-18x53y19z',
                26: '-1x0y79z',
                27: '-1x6y7z',
                28: '-1x9y28z',
                29: '-21x52y19z',
                30: '-22x55y67z',
                31: '-22x8y43z',
                32: '-23x51y18z',
                33: '-23x7y43z',
                34: '-24x3y16z',
                35: '-24x6y43z',
                36: '-25x0y15z',
                37: '-25x1y15z',
                38: '-25x2y16z',
                39: '-25x4y42z',
                40: '-25x5y42z',
                41: '-26x2y42z',
                42: '-26x50y18z',
                43: '-27x0y41z',
                44: '-27x1y42z',
                45: '-29x49y17z',
                46: '-2x0y79z',
                47: '-2x6y6z',
                48: '-2x6y7z',
                49: '-2x9y28z',
                50: '-31x47y17z',
                51: '-34x46y16z',
                52: '-37x44y15z',
                53: '-39x42y15z',
                54: '-3x0y79z',
                55: '-3x6y6z',
                56: '-3x9y28z',
                57: '-41x40y14z',
                58: '-43x38y14z',
                59: '-45x36y13z',
                60: '-4x0y79z',
                61: '-4x5y6z',
                62: '-4x6y6z',
                63: '-4x9y27z',
                64: '-4x9y28z',
                65: '-55x39y15z',
                66: '-57x36y14z',
                67: '-59x33y13z',
                68: '-5x0y79z',
                69: '-5x46y18z',
                70: '-5x5y6z',
                71: '-5x9y27z',
                72: '-61x30y13z',
                73: '-63x27y12z',
                74: '-64x23y11z',
                75: '-66x20y11z',
                76: '-67x13y9z',
                77: '-67x17y10z',
                78: '-68x9y9z',
                79: '-69x2y7z',
                80: '-69x6y8z',
                81: '-6x0y79z',
                82: '-7x0y79z',
                83: '-7x45y18z',
                84: '-8x12y36z',
                85: '-8x49y62z',
                86: '-9x12y36z',
                87: '0x0y79z',
                88: '0x6y7z',
                89: '0x8y28z'}
       
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire10five4xi" usage = "target function for charge104xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire10five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE10FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE10FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE10FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE10FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE10FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five104xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE10FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE10FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE10FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five104xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five104xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE10FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE10FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE10FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire10five4xi.py                             
# -------------------------------------------------------------------------------------------------          